// ==UserScript==
// @name           amazon-integration
// @include        http://www.amazon.*/*
// @version        @VERSION@
// @author         WebApps Team
// @require        utils.js
// ==/UserScript==

window.Unity = external.getUnityObject(1);

function isCorrectPage() {
    var i, ids = ['nav-logo', 'nav-cross-shop-links', 'nav-cross-shop-links', 'welcomeRowTable'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function unityLoaded() {
    function addAction(name, uri) {
        var fullUri = 'http://' + window.location.hostname + '/' + uri;

        Unity.Launcher.addAction(name, makeRedirector(fullUri));
    }
    addAction(_('Basket'), 'gp/cart/view.html');
    addAction(_('Wishlist'), 'gp/registry/wishlist/');
    addAction(_('Orders'), 'gp/css/history/orders/view.html');
    addAction(_('Manage your Kindle'), 'gp/digital/fiona/manage');

    var buyButton = document.getElementById('buyButton');
    if (buyButton) {
        Unity.addAction('/1-Action order', function () { click(buyButton); });
    }

    var addToWishList = document.evaluate('//input[@name="submit.add-to-registry.wishlist"]', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue;
    if (addToWishList) {
        Unity.addAction('/Add to Wish List', function () { click(addToWishList); });
    }

    var showSimilar = document.evaluate('//div[@id="vtpsims"]/div/b/a', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue;
    if (showSimilar) {
        Unity.addAction('/Show similar', function () { click(showSimilar); });
    }
}

if (isCorrectPage()) {
    Unity.toDataURL('http://upload.wikimedia.org/wikipedia/commons/thumb/6/62/Amazon.com-Logo.svg/1000px-Amazon.com-Logo.svg.png', function (aResult, uri) {
        Unity.init({ name: window.location.hostname,
                     iconUrl: uri,
                     onInit: wrapCallback(unityLoaded) });
    });
}
