// ==UserScript==
// @name          mail-ru-integration
// @include       http://*.mail.ru/*
// @include       http://mail.ru/
// @version       @VERSION@
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

window.Unity = external.getUnityObject(1);

function isCorrectPage() {
    var i, ids = ['g_mail_events'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function messagingIndicatorSetup() {
    var countElement = document.getElementById('g_mail_events');
    function checkMessangesCount() {
        var count = countElement.textContent;

        Unity.MessagingIndicator.showIndicator(_("Inbox"), { count: count });
    }

    countElement.addEventListener('DOMSubtreeModified', wrapCallback(checkMessangesCount), false);

    checkMessangesCount();
}

if (isCorrectPage()) {
    Unity.init({ name: _("mail.ru"),
                 iconUrl: "icon://mail-ru",
                 onInit: wrapCallback(messagingIndicatorSetup) });
}

